1
0
mirror of git://projects.qi-hardware.com/openwrt-xburst.git synced 2024-08-21 20:28:02 +03:00
openwrt-xburst/package/madwifi/files/lib/wifi/madwifi.sh

237 lines
4.9 KiB
Bash
Raw Normal View History

#!/bin/sh
append DRIVERS "atheros"
scan_atheros() {
local device="$1"
local wds
local adhoc sta ap
config_get vifs "$device" vifs
for vif in $vifs; do
config_get ifname "$vif" ifname
config_set "$vif" ifname "${ifname:-ath}"
config_get mode "$vif" mode
case "$mode" in
adhoc|sta|ap)
append $mode "$vif"
;;
wds)
config_get addr "$vif" bssid
config_get ssid "$vif" ssid
[ -z "$addr" -a -n "$ssid" ] && {
config_set "$vif" wds 1
config_set "$vif" mode sta
mode="sta"
addr="$ssid"
}
${addr:+append $mode "$vif"}
;;
*) echo "$device($vif): Invalid mode, ignored."; continue;;
esac
done
case "${adhoc:+1}:${sta:+1}:${ap+1}" in
# valid mode combinations
1::) wds="";;
:1:1)config_set "$device" nosbeacon 1;; # AP+STA, can't use beacon timers for STA
:1:);;
::1);;
:::);;
*) echo "$device: Invalid mode combination in config"; return 1;;
esac
config_set "$device" vifs "${ap:+$ap }${adhoc:+$adhoc }${sta:+$sta }${wds:+$wds }"
}
hostapd_setup_vif() {
local vif="$1"
local driver="$2"
local hostapd_cfg=
# Examples:
# psk-mixed/tkip => WPA1+2 PSK, TKIP
# wpa-psk2/tkip+aes => WPA2 PSK, CCMP+TKIP
# wpa2/tkip+aes => WPA2 RADIUS, CCMP+TKIP
# ...
# TODO: move this parsing function somewhere generic, so that
# later it can be reused by drivers that don't use hostapd
# crypto defaults: WPA2 vs WPA1
case "$enc" in
wpa2*|WPA2*|*PSK2*|*psk2*)
wpa=2
crypto="CCMP"
;;
*mixed*)
wpa=3
crypto="CCMP TKIP"
;;
*)
wpa=1
crypto="TKIP"
;;
esac
# explicit override for crypto setting
case "$enc" in
*tkip+aes|*TKIP+AES|*tkip+ccmp|*TKIP+CCMP) crypto="CCMP TKIP";;
*tkip|*TKIP) crypto="TKIP";;
*aes|*AES|*ccmp|*CCMP) crypto="CCMP";;
esac
# use crypto/auth settings for building the hostapd config
case "$enc" in
*psk*|*PSK*)
config_get psk "$vif" key
append hostapd_cfg "wpa_passphrase=$psk" "$N"
;;
*wpa*|*WPA*)
# FIXME: add wpa+radius here
;;
*)
return 0;
;;
esac
config_get ifname "$vif" ifname
config_get bridge "$vif" bridge
config_get ssid "$vif" ssid
cat > /var/run/hostapd-$ifname.conf <<EOF
driver=$driver
interface=$ifname
${bridge:+bridge=$bridge}
ssid=$ssid
debug=0
wpa=$wpa
wpa_pairwise=$crypto
$hostapd_cfg
EOF
hostapd -B /var/run/hostapd-$ifname.conf
}
disable_atheros() (
local device="$1"
# kill all running hostapd and wpa_supplicant processes that
# are running on atheros vifs
for pid in `pidof hostapd wpa_supplicant`; do
grep ath /proc/$pid/cmdline >/dev/null && \
kill $pid
done
include /lib/network
cd /proc/sys/net
for dev in *; do
grep "$device" "$dev/%parent" >/dev/null 2>/dev/null && {
ifconfig "$dev" down
unbridge "$dev"
wlanconfig "$dev" destroy
}
done
return 0
)
enable_atheros() {
config_get channel "$device" channel
config_get vifs "$device" vifs
disable_atheros "$device"
for vif in $vifs; do
nosbeacon=
config_get ifname "$vif" ifname
config_get enc "$vif" encryption
config_get mode "$vif" mode
[ "$mode" = sta ] && config_get nosbeacon "$device" nosbeacon
config_get ifname "$vif" ifname
ifname=$(wlanconfig "$ifname" create wlandev "$device" wlanmode "$mode" ${nosbeacon:+nosbeacon})
[ $? -ne 0 ] && {
echo "enable_atheros($device): Failed to set up $mode vif $ifname" >&2
continue
}
config_set "$vif" ifname "$ifname"
config_get wds "$vif" wds
case "$wds" in
1|on|enabled) wds=1;;
*) wds=0;;
esac
iwpriv "$ifname" wds "$wds"
wpa=
case "$enc" in
WEP|wep)
for idx in 1 2 3 4; do
config_get key "$vif" "key${idx}"
iwconfig "$ifname" enc "[$idx]" "${key:-off}"
done
config_get key "$vif" key
iwconfig "$ifname" enc "[${key:-1}]"
;;
esac
case "$mode" in
wds)
config_get addr "$vif" bssid
iwpriv "$ifname" wds_add "$addr"
;;
*)
config_get ssid "$vif" ssid
;;
esac
iwconfig "$ifname" channel "$channel"
ifconfig "$ifname" up
local net_cfg bridge
net_cfg="$(find_net_config "$vif")"
[ -z "$net_cfg" ] || {
bridge="$(bridge_interface "$net_cfg")"
config_set "$vif" bridge "$bridge"
start_net "$ifname" "$net_cfg"
}
case "$mode" in
ap)
hostapd_setup_vif "$vif" madwifi || {
echo "enable_atheros($device): Failed to set up wpa for interface $ifname" >&2
# make sure this wifi interface won't accidentally stay open without encryption
ifconfig "$ifname" down
wlanconfig "$ifname" destroy
continue
}
;;
wds|sta)
iwconfig "$ifname" essid "$ssid"
# FIXME: implement wpa_supplicant calls here
;;
esac
done
}
detect_atheros() {
cd /proc/sys/dev
[ -d ath ] || return
for dev in wifi*; do
config_get type "$dev" type
[ "$type" = atheros ] && return
cat <<EOF
config wifi-device $dev
option type atheros
option channel 5
config wifi-iface
option device $dev
# option network lan
option mode ap
option ssid OpenWrt
option hidden 0
option encryption none
EOF
done
}